#
# Conditional build:
%bcond_without	kernelsrc	# probes which require full kernel source (kvm, btrfs, ext4, regmap)
%bcond_with	verbose		# verbose build (V=1)

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		rel	1
%define		pname	lttng-modules
Summary:	LTTng 2.x kernel modules
Summary(pl.UTF-8):	Moduły jądra LTTng 2.x
Name:		%{pname}%{_alt_kernel}
Version:	2.12.3
Release:	%{rel}@%{_kernel_ver_str}
License:	GPL v2
Group:		Base/Kernel
Source0:	https://lttng.org/files/lttng-modules/%{pname}-%{version}.tar.bz2
# Source0-md5:	0855c75f8ed1804bffca5e5fa5017993
Patch0:		build.patch
Patch1:		git.patch
URL:		https://lttng.org/
%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:3.0}
%{?with_kernelsrc:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-source >= 3:3.0}}
BuildRequires:	rpmbuild(macros) >= 1.746
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LTTng 2.x kernel modules.

%description -l pl.UTF-8
Moduły jądra LTTng 2.x.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-lttng\
Summary:	LTTng 2.x modules for Linux kernel\
Summary(pl.UTF-8):	Moduły LTTng 2.x dla jądra Linuksa\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-lttng\
LTTng 2.x modules for Linux kernel.\
\
%description -n kernel%{_alt_kernel}-lttng -l pl.UTF-8\
Moduły LTTng 2.x dla jądra Linuksa.\
\
%files -n kernel%{_alt_kernel}-lttng\
%defattr(644,root,root,755)\
%doc %{pname}-%{version}/{ChangeLog,LICENSE,README.md,TODO}\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-clock.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-ring-buffer-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-statedump.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-tracer.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-wrapper.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/lib\
/lib/modules/%{_kernel_ver}/kernel/lttng/lib/lttng-lib-ring-buffer.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/probes\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kretprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-probe-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-uprobes.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/tests\
/lib/modules/%{_kernel_ver}/kernel/lttng/tests/lttng-clock-plugin-test.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/tests/lttng-test.ko*\
\
%post	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%{__make} clean \\\
	KERNELDIR=%{_kernelsrcdir}\
%{__make} \\\
	KERNELDIR=%{_kernelsrcdir}\
p=`pwd`\
%{__make} modules_install \\\
	INSTALL_MOD_PATH=$p/../installed \\\
	INSTALL_MOD_DIR=kernel/lttng \\\
	KERNELDIR=%{_kernelsrcdir}\
%{nil}

%{expand:%create_kernel_packages}

%prep
%setup -qc
cd  %{pname}-%{version}
%patch0 -p1
%patch1 -p1

%build
cd  %{pname}-%{version}
%{expand:%build_kernel_packages}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT

cp -a installed/* $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT
%changelog
* Sat Dec 12 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lttng-modules.git;a=log;h=auto/th/lttng-modules-2.12.3-1

* Sat Nov 28 2020 Jan Rękorajski <baggins@pld-linux.org> b704ebb
- up to 2.2.13 + latest fixes

* Sat Sep 26 2020 Jan Rękorajski <baggins@pld-linux.org> f9dfa75
- add fixes from upstream git with fixes to build modules on recent kernels
- rel 2

* Sun Aug 16 2020 Jan Rękorajski <baggins@pld-linux.org> aa9cd3d
- up to 2.12.2

* Fri Jun 05 2020 Jan Rękorajski <baggins@pld-linux.org> 10babb8
- up to 2.12.1

* Tue Apr 14 2020 Jakub Bogusz <qboosh@pld-linux.org> 9a3ded0
- updated to 2.12.0 (for Linux 3.0+; ftrace integration dropped)
- removed obsolete kernel-5.5.3 patch

* Sat Apr 04 2020 Jan Rękorajski <baggins@pld-linux.org> 3efbae2
- up to 2.11.2

* Sun Feb 23 2020 Jan Rękorajski <baggins@pld-linux.org> 87b6b5d
- fix version macro

* Sun Feb 23 2020 Jan Rękorajski <baggins@pld-linux.org> e66d568
- 4.14 doesn't need this

* Sun Feb 23 2020 Jan Rękorajski <baggins@pld-linux.org> 50a7834
- enable fix on all kernels

* Sun Feb 23 2020 Jan Rękorajski <baggins@pld-linux.org> 0c8875f
- 5.4 also needs this

* Sun Feb 23 2020 Jan Rękorajski <baggins@pld-linux.org> bbbacb5
- fix paths in patch

* Sun Feb 23 2020 Jan Rękorajski <baggins@pld-linux.org> d4618bf
- fix building with kernel 5.5.3+
- rel 2

* Wed Jan 29 2020 Jan Rękorajski <baggins@pld-linux.org> 4144a1b
- up to 2.11.1

* Sun Dec 01 2019 Jan Rękorajski <baggins@pld-linux.org> b91196d
- rework build dirs to make sure we clean them between building for different kernels
- rel 2

* Sat Nov 30 2019 Jan Rękorajski <baggins@pld-linux.org> 04f5de0
- up to 2.11.0

* Sat Oct 26 2019 Jakub Bogusz <qboosh@pld-linux.org> e3bbd49
- updated to 2.10.12

* Fri Jul 12 2019 Jan Rękorajski <baggins@pld-linux.org> 882dfc8
- up to 2.10.10

* Tue May 07 2019 Jan Rękorajski <baggins@pld-linux.org> 8cdc335
- fix building with kernel 5.1
- rel 2

* Fri Mar 29 2019 Jakub Bogusz <qboosh@pld-linux.org> c281bdf
- updated to 2.10.9
- removed obsolete kernel-4.20,kernel-5.0 patches

* Tue Mar 12 2019 Jan Rękorajski <baggins@pld-linux.org> a20a7cd
- rel 2

